function ret=exportFeatureset(dataSet,path)
%Saves the set of biometric signatures and corresponding identities in a
%binary fle
%Format:    totIds (uint32)
%           ID_1 (uint32)   codeLength (uint32) binary_code_1 (uchar)
%           ...
%Parameter 1: IDs vector
%Parameter 2: codes matrix (1 subject per row)
%Parameter 3: Dimensions of the signature bits (ROWS COLS SCALES)
%Parameter 4: pathname

fileHandle=fopen(path,'w');

fwrite(fileHandle,uint32(size(dataSet,1)),'uint32');
fwrite(fileHandle,uint32(size(dataSet,2)),'uint32');
for i=1:size(dataSet,1)
    for j=1:size(dataSet,2)
        fwrite(fileHandle,single(dataSet(i,j)),'double');              
    end
end

fclose(fileHandle);

ret=0;

