/*
 *  LDA.h
 *  TestALGIB
 *
 *  Created by Hugo Proença on 8/25/12.
 *  Copyright 2012 __MyCompanyName__. All rights reserved.
 *
 */

void createLDAsTree(VPT *tree, double **dataset, unsigned int rows, unsigned int cols);
void createLDAsTree_mc(VPT *tree, double **dataset, unsigned int rows, unsigned int cols, unsigned int totClasses);
unsigned int countClasses(unsigned int *ids, unsigned int totIds, double **dataset, unsigned int rows, unsigned int cols);
double** setMultiClassInfo(VPT *tree, double **dataset, unsigned int rows, unsigned int cols);



void createLDAsTree(VPT *tree, double **dataset, unsigned int rows, unsigned int cols){
	if (tree==NULL)
		return;
	
	if (tree->totIds>0){
		std::cout<<"Vai criar LDA para "<<tree->totIds<<"\n";
		for (int i=0; i<tree->totIds; i++)
			std::cout<<tree->ids[i]<<" ";
		std::cout<<"\n";
			
		
		
		alglib::ae_int_t nPoints=tree->totIds;
		alglib::ae_int_t nVars=cols-1;
		alglib::ae_int_t nClasses=2;
		
		alglib::real_2d_array data;
		data.setlength(nPoints,nVars+1);
		alglib::integer_1d_array classes;
		classes.setlength(nPoints);
		
		int tot0=0;
		for(unsigned int i=0;i< nPoints;i++) {
			for(unsigned int j=0;j<nVars+1;j++) 
				data[i][j]=dataset[tree->ids[i]][j];
			classes[i]=(int)data[i][nVars];
			if (classes[i]==0)
				tot0++;
			
		}

		for(unsigned int i=0;i<nPoints;i++) {
		std::cout<<" DATA>>>>>>>>>>>>>>>>>>>>> "<<i<<"\n"; 			
			for(unsigned int j=0;j<nVars+1;j++) 
				std::cout << data[i][j] << " ";
			std::cout << std::endl; 
		}

		
		
		alglib::ae_int_t info;
		alglib::real_1d_array output;	
		std::cout<<"Tot IDs: "<<nPoints<<" Dimension "<<nVars<<" Tot Cla: "<<nClasses<<"\n";
		alglib::fisherlda(data,nPoints,nVars,nClasses,info,output);
		

		std::cout <<"INFO: "<<info<<"\n WEIGHTS: ";		
		for(unsigned int j=0;j<nVars;j++)
			std::cout<<output[j]<<" ";
		std::cout<<"\n";

		int lixo;
		std::cin>>lixo;
		
		
		tree->totWeights=nVars;
		tree->weightsLDA=(double*)malloc(tree->totWeights*sizeof(double));
		for(unsigned int j=0;j<nVars;j++)
			tree->weightsLDA[j]=output[j];
			
						
		alglib::real_1d_array projected;
		projected.setlength(nPoints);
		
//		if ((tot0>0)&&(tot0<tree->totIds)){
			

		
		
		
		for (unsigned int i=0;i<nPoints;i++){
			projected[i]=0;
//			std::cout<<"POS ["<<i<<"]=";
			for (unsigned int j=0; j<nVars; j++){				
				projected[i]+=data[i][j]*output[j];
//				std::cout<<data[i][j]<<"*"<<output[j]/*<<"("<<projected[i]<<")"*/<<"+";
			}
//			std::cout<<""<<projected[i]<<"\n";
//		}
/*
			for (unsigned int i=0;i<nPoints;i++){
				std::cout<<" Tot_["<<i<<"]"<<projected[i]<<"\n";
			}
			
			int lixo2=0;
			std::cin>>lixo2;
 */
			}
		
		/*
		double threshold, pal, pbl, par, pbr, cve, totMenor=0;
		
		alglib::dsoptimalsplit2(projected,classes,nPoints,info,threshold,pal,pbl,par,pbr,cve);
		
		for (unsigned int i=0;i<nPoints;i++)
			totMenor=projected[i]<threshold?totMenor+1:totMenor;
		
		double pMenor=totMenor/nPoints, pError;
		
		pError=pal*pMenor+pbr*(1-pMenor)<pbl*pMenor+par*(1-pMenor)?pal*pMenor+pbr*(1-pMenor):pbl*pMenor+par*(1-pMenor);
		
		std::cout <<"INFO: "<<info<<" THRESHOLD: "<<threshold<<" P(0|v<T):"<<pal<<" P(1|v<T):"<<pbl<<" P(0|v>=T):"<<par<<" P(1|v>=T):"<<
		pbr<<" P(v<T):"<<pMenor<<" P(v>=T):"<<1-pMenor<<" P(Error):"<<pError<<std::endl;
		*/
		
		
		
		unsigned int *positions=(unsigned int*)malloc(nPoints*sizeof(unsigned int));
		
		double *proj=(double*)malloc(nPoints*sizeof(double));
		for (unsigned int i=0;i<nPoints; i++){
			positions[i]=i;
			proj[i]=projected[i];
		}
		
		quickSort(proj,0,(int)nPoints-1,positions);
		
		
/*		
		if ((tot0>0)&&(tot0<tree->totIds)){
			
			
			
			
			
			for (unsigned int i=0;i<nPoints;i++){
					std::cout<<" Tot_"<<projected[i]<<"\n";
				}
			int lixo2=0;
			std::cin>>lixo2;
		}
*/
		
		double t0=0, t1=0;
		tree->error=1;
		for (int i=0; i<nPoints; i++){
			
			if (classes[positions[i]]==0)
				t0++;
			else
				t1++;		
			
			double e=(t0+((nPoints-tot0)-t1))/nPoints<(t1+(tot0-t0))/nPoints?(t0+((nPoints-tot0)-t1))/nPoints:(t1+(tot0-t0))/nPoints;
			if (e<tree->error){
				if ((t0+((nPoints-tot0)-t1))/nPoints<(t1+(tot0-t0))/nPoints)
					tree->sign=1;
				else
					tree->sign=2;
				if (i<nPoints-1)
					tree->threshold=(proj[i]+proj[i+1])/2;
				else 
					tree->threshold=proj[i]+1e-10;
				tree->error=e;


			}
		}
		free(positions);
//		std::cout<<" MCP Error: "<<tree->error<<" THRESHOLD:"<<tree->threshold<<" Tots "<<t0<<", "<<t1<<std::endl;
		
		/*
		std::cout <<"[0]: ";
		for (unsigned int i=0; i<nPoints; i++)
			if (classes[i]==0)
				std::cout<<projected[i]<<" "; 
		std::cout <<"\n[1]: ";		
		for (unsigned int i=0; i<nPoints; i++)
			if (classes[i]==1)
				std::cout<<projected[i]<<" ";

		std::cout<<"\n";
		 */
//		int lixo;
//		std::cin>> lixo;
		
	}
	for (unsigned int i=0; i< tree->totFilhos; i++)
		createLDAsTree(tree->filhos[i], dataset,rows,cols);	
	
}


double** setMultiClassInfo(VPT *tree, double **dataset, unsigned int rows, unsigned int cols){
	
	double **ret=NULL;
	tree->dimension=cols-1;						
	for (unsigned int i=0; i<tree->totIds; i++){
		bool esta=false;
		for (unsigned int j=0; j<tree->totPerClass; j++){
			if (dataset[tree->ids[i]][cols-1]==j){
				esta=true;
					
				for (unsigned int k=0;k<tree->dimension; k++)
					ret[j][k]=ret[j][k]+dataset[tree->ids[i]][k];				
				break;
			}
		}
		if (!esta){
			tree->classes=(double*)realloc(tree->classes,(++tree->totClasses)*sizeof(double));
			tree->classes[tree->totClasses-1]=dataset[tree->ids[i]][cols-1];
			totsPerClass=(unsigned int*)realloc(totsPerClass,tree->totClasses*sizeof(unsigned int));
			totsPerClass[tree->totClasses-1]=1;
						
			ret=(double**)realloc(ret,tree->totClasses*sizeof(double*));
			ret[tree->totClasses-1]=(double*)malloc(tree->dimension*sizeof(double));
			for (unsigned int j=0;j<tree->dimension; j++)
				ret[tree->totClasses-1][j]=dataset[tree->ids[i]][j];			
		}		
	}
	for (unsigned int i=0; i<tree->totClasses; i++)
		for (unsigned int j=0; j<tree->dimension; j++)
			ret[i][j]=ret[i][j]/totsPerClass[i];
	
	tree->projectionCentroids=(double**)malloc(tree->totClasses*sizeof(double*));		
	for (unsigned int i=0; i<tree->totClasses; i++)
		tree->projectionCentroids[i]=(double*)malloc((tree->totClasses-1)*sizeof(double));
	
	free(totsPerClass);
	return(ret);		
	
}


void createLDAsTree_mc(VPT *tree, double **dataset, unsigned int rows, unsigned int cols, unsigned int totClasses){
	if (tree==NULL)
		return;
	
	if (tree->totIds>0){
		
		tree->totClasses=totClasses;
		tree->totPerClass=(unsigned int*)calloc(tree->totClasses,sizeof(unsigned int));
		
		
		std::cout<<"Vai criar LDA para "<<tree->totIds<<"\n";
		for (int i=0; i<tree->totIds; i++)
			std::cout<<tree->ids[i]<<" ";
		std::cout<<"\n";
		
		
		
		
		double **centroids=setMultiClassInfo(tree, dataset, rows, cols);
		
		
		
		
		
		alglib::real_2d_array data;
		data.setlength(tree->totIds,tree->dimension+1);
		alglib::integer_1d_array classes;
		classes.setlength(tree->totIds);
		
		
		
		int *totPerClass=(int*)calloc(tree->totClasses,sizeof(int));
									  									  
		for(unsigned int i=0;i< tree->totIds;i++) {
			for(unsigned int j=0;j<tree->dimension+1;j++) 
				data[i][j]=dataset[tree->ids[i]][j];
			classes[i]=(int)data[i][tree->dimension];
			totPerClass[i]++;						
		}

		std::cout<<"Tot Classes: "<<tree->totClasses<<" Tot Per Class:\n";
		 for(unsigned int i=0;i<tree->totClasses;i++) 
			 std::cout<<classes[i]<<" T "<<totPerClass[i]<<" ";
		 std::cout << std::endl; 

/*		
		alglib::ae_int_t info1;
		alglib::real_1d_array output1;
		std::cout<<"Tot IDs: "<<tree->totIds<<" Dimension "<<tree->dimension<<" Tot Cla: "<<tree->totClasses<<"\n";
		alglib::fisherlda(data,tree->totIds,tree->dimension,,info1,output1);				
		std::cout <<"(Out LDA) INFO: "<<info1<<"\n ";		
	
		for(unsigned int i=0;i<tree->totIds;i++) {
			std::cout<<" DATA>>>>>>>>>>>>>>>>>>>>> "<<i<<"\n"; 			
			for(unsigned int j=0;j<tree->dimension+1;j++) 
				std::cout << data[i][j] << " ";
			std::cout << std::endl; 
		}
		
*/		
		
		
		
		alglib::ae_int_t info;
		alglib::real_2d_array output;		
		alglib::fisherldan(data,tree->totIds,tree->dimension,tree->totClasses,info,output);
		
		std::cout <<"(Out LDA_mc) INFO: "<<info<<"\n WEIGHTS: ";		
		for (unsigned int i=0; i<tree->totClasses-1; i++){ 
			std::cout<<"Vector "<<i<<"\n";
			for(unsigned int j=0;j<tree->dimension;j++)
				std::cout<<output[i][j]<<" ";
			std::cout<<"\n";
		}
		

		int lixo;
		std::cin>>lixo;

		
		tree->totWeights=tree->dimension*(tree->totClasses-1);
		tree->weightsLDA=(double*)malloc(tree->totWeights*sizeof(double));
		unsigned int index=0;
		for (unsigned int i=0; i<tree->dimension; i++)
			for(unsigned int j=0;j<tree->totClasses-1;j++)
			tree->weightsLDA[index++]=output[i][j];
		
		
		for (unsigned int i=0; i<tree->totClasses; i++){
			
			
			for (unsigned int k=0; k<tree->totClasses-1; k++){
				for (unsigned int j=0; j<tree->dimension; j++){
					tree->projectionCentroids[i][k]=tree->projectionCentroids[i][k]+centroids[i][j]*tree->weightsLDA[k*tree->dimension+j];
				}
			}
			
		}
		
				
		for (unsigned int i=0; i<tree->totClasses; i++)
			free(centroids[i]);
		free(centroids);
								
		
	}
	for (unsigned int i=0; i< tree->totFilhos; i++)
		createLDAsTree_mc(tree->filhos[i], dataset,rows,cols, totClasses);	
	
}